﻿Imports System.Data.Common
Imports System.Data.SqlClient
Imports System.IO

Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'Database1DataSet.klant' table. You can move, or remove it, as needed.
        Me.KlantTableAdapter.Fill(Me.Database1DataSet.klant)

    End Sub

    Private Sub BtnImport_Click(sender As Object, e As EventArgs) Handles BtnImport.Click
        If OpenFileDialog1.ShowDialog = DialogResult.OK Then
            Dim filename As String = OpenFileDialog1.FileName
            Dim Lijst As List(Of Persoon) = LeesBestand(filename)
            VulDatabank(Lijst)
            Me.KlantTableAdapter.Fill(Me.Database1DataSet.klant)
        End If
    End Sub
    Private Sub VulDatabank(Lijst As List(Of Persoon))
        Using conn As DbConnection = New SqlConnection(My.Settings.Database1ConnectionString),
                command As SqlCommand = conn.CreateCommand
            command.CommandText = "INSERT INTO klant (naam, postnr) VALUES (@naam, @postnr)"
            command.Parameters.Add("@naam", SqlDbType.VarChar)
            command.Parameters.Add("@postnr", SqlDbType.Char, 4)
            conn.Open()
            For Each p As Persoon In Lijst
                Try
                    command.Parameters("@naam").Value = p.Naam
                    command.Parameters("@postnr").Value = p.Postnr
                    command.ExecuteNonQuery()
                Catch ex As SqlException
                    MessageBox.Show(String.Format("{0} kon niet worden toegevoegd", p.Naam))
                End Try
            Next
        End Using
    End Sub
    Private Function LeesBestand(bestand As String) As List(Of Persoon)
        Dim Lijst As List(Of Persoon) = New List(Of Persoon)
        Using reader As StreamReader = New StreamReader(bestand)
            Dim lijn As String = reader.ReadLine
            While lijn IsNot Nothing
                Dim p As Persoon = New Persoon(lijn)
                Lijst.Add(p)
                lijn = reader.ReadLine
            End While
        End Using
        Return Lijst
    End Function

    Private Sub BtnImportUpdate_Click(sender As Object, e As EventArgs) Handles BtnImportUpdate.Click
        If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
            Dim lijst As List(Of UpdatePersoon) = LeesUpdateBestand(OpenFileDialog1.FileName)
            VulUpdateDatabank(lijst)
            Me.KlantTableAdapter.Fill(Me.Database1DataSet.klant)
        End If
    End Sub
    Private Function LeesUpdateBestand(bestand As String) As List(Of UpdatePersoon)
        Dim lijst As List(Of UpdatePersoon) = New List(Of UpdatePersoon)
        Using reader As StreamReader = New StreamReader(bestand)
            Dim lijn As String = reader.ReadLine
            While lijn IsNot Nothing
                Dim p As UpdatePersoon = New UpdatePersoon(lijn)
                lijst.Add(p)
                lijn = reader.ReadLine
            End While
        End Using
        Return lijst
    End Function
    Private Sub VulUpdateDatabank(lijst As List(Of UpdatePersoon))
        Using conn As DbConnection = New SqlConnection(My.Settings.Database1ConnectionString),
                deletecommand As SqlCommand = conn.CreateCommand,
                updatecommand As SqlCommand = conn.CreateCommand,
                insertcommand As SqlCommand = conn.CreateCommand
            deletecommand.CommandText = "DELETE FROM klant WHERE naam = @naam and postnr = @postnr"
            deletecommand.Parameters.Add("@naam", SqlDbType.VarChar)
            deletecommand.Parameters.Add("@postnr", SqlDbType.Char, 4)
            updatecommand.CommandText = "UPDATE klant SET postnr = @postnr where naam = @naam"
            updatecommand.Parameters.Add("@naam", SqlDbType.VarChar)
            updatecommand.Parameters.Add("@postnr", SqlDbType.Char, 4)
            insertcommand.CommandText = "INSERT INTO klant (naam, postnr) VALUES (@naam, @postnr)"
            insertcommand.Parameters.Add("@naam", SqlDbType.VarChar)
            insertcommand.Parameters.Add("@postnr", SqlDbType.Char, 4)
            conn.Open()
            For Each p As UpdatePersoon In lijst
                Select Case p.Update
                    Case DbUpdate.Insert
                        insertcommand.Parameters("@naam").Value = p.Naam
                        insertcommand.Parameters("@postnr").Value = p.Postnr
                        insertcommand.ExecuteNonQuery()
                    Case DbUpdate.Delete
                        deletecommand.Parameters("@naam").Value = p.Naam
                        deletecommand.Parameters("@postnr").Value = p.Postnr
                        deletecommand.ExecuteNonQuery()
                    Case DbUpdate.Update
                        updatecommand.Parameters("@naam").Value = p.Naam
                        updatecommand.Parameters("@postnr").Value = p.Postnr
                        updatecommand.ExecuteNonQuery()
                End Select
            Next

        End Using

    End Sub
End Class
